/**
 * Created By Akansha
 * This file provides the necessary bean creation for the Form Tab.
 * *******************************************************************************************************************************
 * Sr No.  		Date			Name						New Addition
 * *******************************************************************************************************************************
 * 
 */
package com.tin.etabf.filecreator;

import java.text.SimpleDateFormat;
import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;
import java.util.Date;
import java.util.Locale;

public class FHBean {
	
	private String LineNumber="1";
	private String RecordType="FH";
	private String FileType="SL1";
	private String UploadType="R";
//	DateTimeFormatter dtf = DateTimeFormatter.ofPattern("ddMMyyyy");
//    LocalDateTime local =LocalDateTime.now();
//    private String CreationDate = dtf.format(local);

	private String CreationDate = new SimpleDateFormat("ddMMyyyy",Locale.ENGLISH).format(new Date());
	private String SequenceNum;
	private String UploaderType;
	private String EmployerTAN;
	private String No_of_Batches;
	private String RPU_Name;
	private String RecordHash;
	private String FVU_Version;
	private String FileHash;
	private String SAMVersion;
	private String SAMHash;
	private String SCMVersion;
	private String SCMHash;
	private String ConsilidatedHash;
	
	
	
	public String getLineNumber() {
		return LineNumber;
	}
	public void setLineNumber(String lineNumber) {
		LineNumber = lineNumber;
	}
	public String getRecordType() {
		return RecordType;
	}
	public void setRecordType(String recordType) {
		RecordType = recordType;
	}
	public String getFileType() {
		return FileType;
	}
	public void setFileType(String fileType) {
		FileType = fileType;
	}
	public String getUploadType() {
		return UploadType;
	}
	public void setUploadType(String uploadType) {
		UploadType = uploadType;
	}
	public String getCreationDate() {
		return CreationDate;
	}
	public void setCreationDate(String creationDate) {
		CreationDate = creationDate;
	}
	public String getSequenceNum() {
		return SequenceNum;
	}
	public void setSequenceNum(String sequenceNum) {
		SequenceNum = sequenceNum;
	}
	public String getUploaderType() {
		return UploaderType;
	}
	public void setUploaderType(String uploaderType) {
		UploaderType = uploaderType;
	}
	public String getEmployerTAN() {
		return EmployerTAN;
	}
	public void setEmployerTAN(String employerTAN) {
		EmployerTAN = employerTAN;
	}
	public String getNo_of_Batches() {
		return No_of_Batches;
	}
	public void setNo_of_Batches(String no_of_Batches) {
		No_of_Batches = no_of_Batches;
	}
	public String getRPU_Name() {
		return RPU_Name;
	}
	public void setRPU_Name(String rPU_Name) {
		RPU_Name = rPU_Name;
	}
	public String getRecordHash() {
		return RecordHash;
	}
	public void setRecordHash(String recordHash) {
		RecordHash = recordHash;
	}
	public String getFVU_Version() {
		return FVU_Version;
	}
	public void setFVU_Version(String fVU_Version) {
		FVU_Version = fVU_Version;
	}
	public String getFileHash() {
		return FileHash;
	}
	public void setFileHash(String fileHash) {
		FileHash = fileHash;
	}
	public String getSAMVersion() {
		return SAMVersion;
	}
	public void setSAMVersion(String sAMVersion) {
		SAMVersion = sAMVersion;
	}
	public String getSAMHash() {
		return SAMHash;
	}
	public void setSAMHash(String sAMHash) {
		SAMHash = sAMHash;
	}
	public String getSCMVersion() {
		return SCMVersion;
	}
	public void setSCMVersion(String sCMVersion) {
		SCMVersion = sCMVersion;
	}
	public String getSCMHash() {
		return SCMHash;
	}
	public void setSCMHash(String sCMHash) {
		SCMHash = sCMHash;
	}
	public String getConsilidatedHash() {
		return ConsilidatedHash;
	}
	public void setConsilidatedHash(String consilidatedHash) {
		ConsilidatedHash = consilidatedHash;
	}
	
	public String toString()
	{
		StringBuilder sb = new StringBuilder();
		
		sb.append(LineNumber);
		sb.append("^");
		sb.append(RecordType);
		sb.append("^");
		
		if(FileType!=null && FileType!="")
		{
		sb.append(FileType);
		} 
		
		sb.append("^");
		
		if(UploadType!=null && UploadType!="")
		{
		sb.append(UploadType);
		}
		
		sb.append("^");
		
		if(CreationDate!=null && CreationDate!="")
		{
		sb.append(CreationDate);
		}
		
		sb.append("^");
		
		if(SequenceNum!=null && SequenceNum!="")
		{
		sb.append(SequenceNum);
		}
		
		sb.append("^");
		
		if(UploaderType!=null && UploaderType!="")
		{
		sb.append(UploaderType);
		}
		
		sb.append("^");
		
		
		if(EmployerTAN!=null && EmployerTAN!="")
		{
			sb.append(EmployerTAN);
		
		}
		
		sb.append("^");
		
		if(No_of_Batches!=null && No_of_Batches!="")
		{
			sb.append(No_of_Batches);
		}
		
		sb.append("^");
		
		if(RPU_Name!=null && RPU_Name!="")
		{
			sb.append(RPU_Name);
		}
		
		sb.append("^");
		
		if(RecordHash!=null && RecordHash!="")
		{
			sb.append(RecordHash);
		}
		
		sb.append("^");
		
		if(FVU_Version!=null && FVU_Version!="")
		{
			sb.append(FVU_Version);
		}
		
		sb.append("^");
		
		if(FileHash!=null && FileHash!="")
		{
			sb.append(FileHash);
		}
		
		sb.append("^");
		
		if(SAMVersion!=null && SAMVersion!="")
		{
			sb.append(SAMVersion);
		}
		
		sb.append("^");
		
		if(SAMHash!=null && SAMHash!="")
		{
			sb.append(SAMHash);
		}
		
		sb.append("^");
		
		if(SCMVersion!=null && SCMVersion!="")
		{
			sb.append(SCMVersion);
		}
		
		sb.append("^");
		
		if(SCMHash!=null && SCMHash!="")
		{
			sb.append(SCMHash);
		}
		
		sb.append("^");
		
		if(ConsilidatedHash!=null && ConsilidatedHash!="")
		{
			sb.append(ConsilidatedHash);
		}
		
		
		return (sb.toString());
	}
	

	
}
